;;;
;;; bitio_tst.lisp : bitio のテスト
;;;
;;; Copyright (c) 2023 Makoto Hiroi
;;;
;;; Released under the MIT license
;;; https://opensource.org/license/mit/
;;;
(provide :bitio_tst)
(defpackage :bitio_tst (:use :cl :bitio :mintst))
(in-package :bitio_tst)
(export '(test))

(defvar bs nil)

(defun test ()
  (initial)
  (call-with-bit-output-file
   "bitio_tst.dat"
   (lambda (s)
     (setq bs s)
     (run (putbit bs 0) nil)
     (run (putbit bs 1) nil)
     (run (putbits bs 4 #b1010) nil)
     (run (putbits bs 8 #b01010101) nil)
     (run (alpha-encode bs 16) nil)
     (run (gamma-encode bs 17) nil)
     (run (delta-encode bs 18) nil)
     (run (cbt-encode bs 11 12 4) nil)
     (run (rice-encode bs 15 3) nil)
     (setq bs nil)))
  (call-with-bit-input-file
   "bitio_tst.dat"
   (lambda (s)
     (setq bs s)
     (run (getbit bs) 0)
     (run (getbit bs) 1)
     (run (getbits bs 4) #b1010)
     (run (getbits bs 8) #b01010101)
     (run (alpha-decode bs) 16)
     (run (gamma-decode bs) 17)
     (run (delta-decode bs) 18)
     (run (cbt-decode bs 12 4) 11)
     (run (rice-decode bs 3) 15)
     (setq bs nil)))
  (final))

