;;;
;;; bitree_tst.lisp : bitree のテスト
;;;
;;; Copyright (C) 2023 Makoto Hiroi
;;;
;;; Released under the MIT license
;;; https://opensource.org/license/mit/
;;;
(provide :bitree_tst)
(defpackage :bitree_tst (:use :cl :mintst :bitree))
(in-package :bitree_tst)
(export '(test))

(defvar bt nil)

(defun test ()
  (initial)
  (run (bitree-p (setq bt (make-bitree 16))) t)
  (run (bitree-total bt) 0)
  (run (dotimes (x 16 (bitree-total bt)) (bitree-add bt x 2)) 32)
  (run (mapcar (lambda (x) (bitree-get bt x)) '(0 8 15))
       '(2 2 2))
  (run (mapcar (lambda (x) (bitree-sum bt x)) '(0 8 15))
       '(0 16 30))
  (run (mapcar (lambda (x) (bitree-find bt x)) '(0 1 16 17 30 31))
       '(0 0 8 8 15 15))
  (run (dolist (x '(0 8 15) (bitree-total bt)) (bitree-add bt x 8)) 56)
  (run (mapcar (lambda (x) (bitree-get bt x)) '(0 4 8 12 15))
       '(10 2 10 2 10))
  (run (mapcar (lambda (x) (bitree-sum bt x)) '(0 4 8 12 15))
       '(0 16 24 40 46))
  (run (mapcar (lambda (x) (bitree-find bt x)) '(0 9 24 33 46 55))
       '(0 0 8 8 15 15))
  (run (progn (bitree-half bt) (bitree-total bt)) 28)
  (run (mapcar (lambda (x) (bitree-get bt x)) '(0 4 8 12 15))
       '(5 1 5 1 5))
  (run (bitree-clear bt) 0)
  (final))

