;;;
;;; queue_tst.lisp : queue のテスト
;;;
;;; Copyright (C) 2023 Makoto Hiroi
;;;
;;; Released under the MIT license
;;; https://opensource.org/license/mit/
;;;
(provide :queue_tst)
(defpackage :queue_tst (:use :cl :queue :mintst))
(in-package :queue_tst)
(export '(test))

(defvar q nil)

(defun test ()
  (initial)
  (run (queue-p (setq q (make-queue))) t)
  (run (ring-buffer-p q) nil)
  (run (queue-emptyp q) t)
  (run (queue-count q) 0)
  (run (dotimes (x 8 (queue-count q)) (enqueue q x)) 8)
  (run (queue-emptyp q) nil)
  (run (queue-fullp q) nil)
  (run (queue-peek q) 0)
  (run (let ((a nil))
	 (dotimes (x 4 (reverse a)) (push (dequeue q) a)))
       '(0 1 2 3))
  (run (queue-emptyp q) nil)
  (run (queue-count q) 4)
  (run (queue-peek q) 4)
  (run (queue-clear q) 0)
  (run (queue-emptyp q) t)
  (run (queue-count q) 0)
  (run (queue-peek q) nil)

  ;; ring-buffer
  (run (ring-buffer-p (setq q (make-ring-buffer 8))) t)
  (run (queue-p q) nil)
  (run (queue-emptyp q) t)
  (run (queue-count q) 0)
  (run (dotimes (x 8 (queue-count q)) (enqueue q x)) 8)
  (run (queue-emptyp q) nil)
  (run (queue-fullp q) t)
  (run (queue-peek q) 0)
  (run (let ((a nil))
	 (dotimes (x 4 (reverse a)) (push (dequeue q) a)))
       '(0 1 2 3))
  (run (queue-emptyp q) nil)
  (run (queue-count q) 4)
  (run (queue-peek q) 4)
  (run (queue-clear q) 0)
  (run (queue-emptyp q) t)
  (run (queue-fullp q) nil)
  (run (queue-count q) 0)
  (run (queue-peek q) nil)
  (final))
    
