;;;
;;; arc_tst.lisp : 適応型 rangecoder のテスト
;;;
;;; Copyright (C) 2023 Makoto Hiroi
;;;
;;; Released under the MIT license
;;; https://opensource.org/license/mit/
;;;
(provide :arc_tst)
(defpackage :arc_tst (:use :cl :mintst :bitree :arc :rangecoder))
(in-package :arc_tst)
(export '(test))

(defvar bt nil)
(defvar rc nil)

(defun test ()
  (initial)
  (setq bt (bitree-initialize 8))
  (call-with-byte-output-file
   "rc_test.en"
   (lambda (out)
     (call-with-range-encoder
      out
      (lambda (r)
	(setq rc r)
	(run (arc-encode rc bt 0) nil)
	(run (arc-encode rc bt 1) nil)
	(run (arc-encode rc bt 2) nil)
	(run (arc-encode rc bt 3) nil)
	(run (arc-encode rc bt 4) nil)
	(run (arc-encode rc bt 5) nil)
	(run (arc-encode rc bt 6) nil)
	(run (arc-encode rc bt 7) nil)))))
  (setq bt (bitree-initialize 8))
  (call-with-byte-input-file
   "rc_test.en"
   (lambda (in)
     (call-with-range-decoder
      in
      (lambda (r)
	(setq rc r)
	(run (arc-decode rc bt) 0)
	(run (arc-decode rc bt) 1)
	(run (arc-decode rc bt) 2)
	(run (arc-decode rc bt) 3)
	(run (arc-decode rc bt) 4)
	(run (arc-decode rc bt) 5)
	(run (arc-decode rc bt) 6)
	(run (arc-decode rc bt) 7)))))
  (final))

